<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_suspended".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderSuspended".
 *
 * Columns in table "provider_suspended" available as properties of the model,
 * followed by relations of table "provider_suspended" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $admin_account_id
 * @property string $date_added
 * @property string $suspended_reason
 *
 * @property Provider $provider
 */
abstract class BaseProviderSuspended extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_suspended';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, admin_account_id, suspended_reason, suspended_reason_details', 'required'),
            array('provider_id, admin_account_id', 'numerical', 'integerOnly' => true),
            array('date_added', 'safe'),
            array(
                'date_added, suspended_reason, suspended_reason_details',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, provider_id, admin_account_id, date_added, suspended_reason, suspended_reason_details',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'admin_account_id' => Yii::t('app', 'Admin Account'),
            'date_added' => Yii::t('app', 'Date Added'),
            'suspended_reason' => Yii::t('app', 'Suspended Reason'),
            'suspended_reason_details' => Yii::t('app', 'Suspended Reason Details'),
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('suspended_reason', $this->suspended_reason);
        $criteria->compare('suspended_reason_details', $this->suspended_reason_details);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderSuspended|ProviderSuspendeds', $n);
    }

}
